#include "vakiot.hh"
#include "yksikot.hh"
#include "yksikko.hh"
#include "summa.hh"
#include "tulo.hh"

/* These come from GNU math.h. Provide      
 * enough digits for the 128-bit IEEE quad.
 */
#define PI 3.1415926535897932384626433832795029L
#define  E 2.7182818284590452353602874713526625L

Vakiot::Vakiot(Yksikot &Yksikot)
{
	autoeqptr<tulo> tmp;
	autoeqptr<summa> tmp2;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]), 1);
	tmp->insert(new yksikko(Yksikot["s"]), -1);
	tmp2 = new summa;
	tmp2->insert(&*tmp, merknum(299792458, 9));
	(*this)["c"] = tmp2;
	
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]), 1);
	tmp->insert(new yksikko(Yksikot["m"]), 2);
	tmp->insert(new yksikko(Yksikot["g"]), -2);
	tmp2 = new summa;
	tmp2->insert(&*tmp, merknum(6.673e-17, 4)); /* /kg^2 = /g/1000000; 11+6=17 */
	(*this)["G"] = tmp2;
	
	tmp2 = new summa;
	tmp2->lisays = merknum(PI, TARKKUUS);
	(*this)["pi"] = tmp2;
	
	tmp2 = new summa;
	tmp2->lisays = merknum(E, TARKKUUS);
	(*this)["e"] = tmp2;
	
	tmp2 = new summa;
	tmp2->lisays = 0.5;
	(*this)[""] = tmp2;
}
