#ifndef bqYksikOt_hh
#define bqYksikOt_hh

#include <map>
#include <string>

#include "tulo.hh"

class Yksikot : public map<string, char>
{
	typedef map<char, string> cstype;
	cstype cs;
	void add(const string &s, char c) { map<string,char>::operator[] (s) = c; cs[c] = s; }
public:
	Yksikot();
	bool has(char c) { return cs.find(c) != cs.end(); }

	const string &operator[] (char c) const { return cs.find(c)->second; }
	inline char operator[] (const string &s) const { return find(s)->second; }
	
	unsigned Test(const string &s, unsigned pos=0)
	{
		unsigned ble=0;
		const_iterator i;
		for(i=begin(); i!=end(); ++i)
			if(i->first.size() >= ble && s.substr(pos, i->first.size()) == i->first)
				ble = i->first.size();
		return ble;
	}
	char Value(const string &s, unsigned pos=0)
	{
		unsigned ble=0;
		const_iterator i, j=end();
		for(i=begin(); i!=end(); ++i)
			if(i->first.size() >= ble && s.substr(pos, i->first.size()) == i->first)
			{
				ble = i->first.size();
				j = i;
			}
		return j->second;
	}
};

class Yksikkomuunnokset
{
	map<tulop, real> elems;
public:
	Yksikkomuunnokset(Yksikot &Yksikot);
};

#endif
